Subject: Re: [RFC 20/20] RDMA/i40iw: Mark i40iw as deprecated

From: Leon Romanovsky <[email-masked]>
Date: Thu, 3 Oct 2019 11:23:33 +0300

On Wed, Oct 02, 2019 at 05:15:45PM -0400, Dennis Dalessandro wrote:
> On 9/28/2019 1:55 AM, Leon Romanovsky wrote:
> > On Fri, Sep 27, 2019 at 04:17:15PM -0400, Doug Ledford wrote:
> > > On Thu, 2019-09-26 at 21:55 +0200, [email-masked] wrote:
> > > > On Thu, Sep 26, 2019 at 07:49:44PM +0000, Saleem, Shiraz wrote:
> > > > > > Subject: Re: [RFC 20/20] RDMA/i40iw: Mark i40iw as deprecated
> > > > > >
> > > > > > On Thu, Sep 26, 2019 at 09:45:19AM -0700, Jeff Kirsher wrote:
> > > > > > > From: Shiraz Saleem <[email-masked]>
> > > > > > >
> > > > > > > Mark i40iw as deprecated/obsolete.
> > > > > > >
> > > > > > > irdma is the replacement driver that supports X722.
> > > > > >
> > > > > > Can you simply delete old one and add MODULE_ALIAS() in new
> > > > > > driver?
> > > > > >
> > > > >
> > > > > Yes, but we thought typically driver has to be deprecated for a few
> > > > > cycles before removing it.
> > > >
> > > > If you completely replace it with something that works the same, why
> > > > keep the old one around at all?
> > > >
> > > > Unless you don't trust your new code?  :)
> > >
> > > I have yet to see, in over 20 years of kernel experience, a new driver
> > > replace an old driver and not initially be more buggy and troublesome
> > > than the old driver.  It takes time and real world usage for the final
> > > issues to get sorted out.  During that time, the fallback is often
> > > necessary for those real world users.
> >
> > How many real users exist in RDMA world who run pure upstream kernel?
>
> I doubt too many especially the latest bleeding edge upstream kernel. That
> could be interesting, but I don't think it's the reality.
>
> Distro kernels could certainly still keep the old driver, and that makes a
> lot of sense.

Also, they are invited to run their regression suite to verify
stability and report any arising problems to upstream/vendor.

Thanks

> -Denny